# -*- coding: utf-8 -*-
"""
Created on Fri Jun  2 10:45:08 2017

@author: odd
"""

import numpy as np
from scipy.integrate import quad
from scipy.special import gamma
import matplotlib.pyplot as plt
omega_n = 2.1
uppcr = omega_n / 2 / np.pi
sigma_x = .24


def damage_intensity(S, beta, sigma_x):
    return (S*2)**(beta) * S / sigma_x**2 * np.exp(-S**2 / 2 / sigma_x**2)



beta = np.linspace(2,5,100)
damage = np.zeros(beta.size) 
i = 0   
for beta_i in beta:
    d_i, e = quad(damage_intensity, 0, np.inf, args=(beta_i, sigma_x))
    damage[i] = d_i  * uppcr
    i += 1
    

D = uppcr * (2**(3*beta/2) * (1. / sigma_x**2)**(-beta / 2) * gamma(beta/2. + 1))    


Dm = np.loadtxt('damage_markov.csv')
Dwafo = np.loadtxt('damage_wafo.csv')
beta_wafo = np.linspace(2,5,Dwafo.size)
beta_markov = np.linspace(2,5,Dm.size)


D2 = np.loadtxt('Damage.csv')
beta2 = np.linspace(2,5, D2.size)
fig, ax = plt.subplots(figsize=(10,7))
ax.plot(beta, D,'--', label='Narrow Banded process', lw=2, alpha=.8)
# ax.plot(beta_wafo, Dwafo,  label='Wafo - Toolbox', lw=2, alpha=.8)
 #ax.plot(beta_markov, Dm,  label='Transition Matrix', lw=2, alpha=.8)
# ax.plot(beta2, D2, label='Wafo2')
ax.legend(fancybox=True, loc='best')
ax.set_xlabel(r'$\beta$',size=20)
ax.set_ylabel(r'Damage Intensity', size=15)