
from cell_mapping import Pmatrix, ARForce_mapping, AR2Force_mapping
import cell_discretization as cell
from scipy.sparse import csc_matrix
import numpy as np


def save_sparse_csc(filename, Matrix, mesh, par):
	fn = '../PROGRAM/saved/matrix/%s' % (filename)
	np.savez(fn, mesh=mesh, par=par, data=Matrix.data, indices=Matrix.indices, indptr=Matrix.indptr, shape=Matrix.shape)
	print 'Matrix saved'


def load_sparse_csc(filename):
	fn = '../PROGRAM/saved/matrix/%s.npz' % (filename)
	loader = np.load(fn)
	mesh = loader['mesh'].item()
	par = loader['par'].item()  # [omega_n, zeta, k, dt, AR1, sigma_w]
	Matrix = csc_matrix((loader['data'], loader['indices'], loader['indptr']), shape=loader['shape'])
	return mesh, par, Matrix


def save_array(filename, array, mesh, par):
	fn = '../PROGRAM/saved/array/%s' % (filename)
	np.savez(fn, mesh=mesh, par=par, array=array)
	print 'Array saved'


def load_array(filename):
	fn = '../PROGRAM/saved/array/%s.npz' % (filename)
	loader = np.load(fn)
	mesh = loader['mesh'].item()
	par = loader['par'].item()
	array = loader['array']
	return mesh, par, array


if __name__ == "__main__":
	filename = 'test'
	Rand_P = 1
	par = cell.par()
	mesh = cell.mesh()
	print mesh.keys()
	# ARForce_mapping(mode=1)
	P = Pmatrix(mesh, par, Rand_P=Rand_P, cells='all', print_progress='yes')
	# print par
	save_sparse_csc(filename, P, mesh, par)
